var TCBData;
self.port.on('TCBData', function(data){
	console.log('TCBData');
	TCBData = data;
	$(document).ready(init);
});
var $body; // jQueryed body element
var bodyMargin; // original body element margin-top
var fixedElements; // cache of fixed position elements
var shifted = false; // currently shifted or not

function shiftPage(sh){ // shift all elements down to make room for banner
	if(sh == shifted){return;} // if already in requested state, return
	var startTime = new Date().getMilliseconds();
	if(sh){ // shifting
		fixedElements = $('*').filter(function(){ // filter all elements to find position: fixed ones
			//return $(this).css('position') === 'fixed'; // keep this element in collection if position fixed
			var $this = $(this); // cache jQueryed element
			var position = $this.css('position'); // store position value for comparisons
			if(position === 'fixed'){
				return true; // element is fixed, keep in collection
			}else if(position === 'absolute'){ // element is position: absolute, need to check parents to see if they are positioned
				var found = false;
				$this.parents().each(function(){ // traverse up through parent elements
					var position = $(this).css('position'); // get position of this (parent) element
					if(position === 'fixed' || position === 'absolute' || position === 'relative'){
						found = true; // found positioned parent element
						return false; // don't need to check any further back in parents, so break this loop early
					}
				});
				if(found){
					return false; // absolutely positioned element with positioned parent element, so skip it
				}else{
					return true; // absolutely positioned element without positioned parent element, so keep it (same as if it were fixed)
				}
			}else{
				return false; // not position: fixed or absolute, so skip it
			}
		});
		fixedElements.css('margin-top', '+=31'); // shift fixed elements
		$body.css('margin-top', '+=31'); // shift main body element
	}else{ // unshifting
		//$body.css('margin-top', bodyMargin);
		$body.css('margin-top', '-=31'); // unshift main body element
		fixedElements.css('margin-top', '-=31'); // unshift previously shifted fixed elements
		fixedElements = null; // clear fixed elements cache
	}
	shifted = sh; // store shifted state
	console.log('Page shifted in '+(new Date().getMilliseconds() - startTime)+' ms');
	if(fixedElements){
		console.log(fixedElements.length+' fixed elements');
	}
}

var tcbnotify; // jQueried notification banner element
var tcbnotifycontent; // jQueried element containing content within banner
var bannerparts = [];
var merchantsdone = {};
var bannertimeout;
//var elementquery = 'div.rc a[href!=""][data-tcbdone!=1]';
var elementquery = 'h3.r a[href!=""][data-tcbdone!=1]';
//var elementqueryads = 'li.ads-ad > h3 > a[href!=""][data-tcbdone!=1]';
var elementqueryads = 'li.ads-ad h3 > a[href!=""][data-tcbdone!=1]';
var waitingcount = 0;
//var bannerchangetime;
//var laststage = 0;
var notifyshowing = false;
var notifydismissed = false;

function setBanner(){ // set content of notification banner, creating/removing it as necessary
	console.log('Setting banner now');
	if(!notifydismissed){ // user has dismissed notification, don't show it anymore within this instance
		html = bannerparts.join(' | ');
		if(html != ''){
			if(tcbnotify == null){ // banner doesn't already exist, so create it
				//tcbnotify = $('<div id="tcbnotify"><span id="tcbnotifycontent"></span> <span class="tcbclose">X</span></div>'); // build notification banner
				tcbnotify = $('<div id="tcbnotify"><img src="'+TCBData.assetspath+'new/ribbon_logo.png" class="tcb_logo"><span id="tcbnotifycontent"></span><span class="tcbclose">X</span></div>'); // build notification banner
				tcbnotifycontent = tcbnotify.find('#tcbnotifycontent'); // cache inner content element
				tcbnotify.find('.tcbclose').click(function(){ // add handler for close button
					shiftPage(false); // shift page up
					tcbnotify.remove(); // remove banner from document
					tcbnotify = null;
					tcbnotifycontent = null;
					notifydismissed = true; // store the fact that the user dismissed the banner
				});
				shiftPage(true); // shift page down
				tcbnotify.insertBefore($body); // insert banner into document
			}
			tcbnotifycontent.html(html);
		}else{
			if(tcbnotify != null){ // no content to show, remove banner
				shiftPage(false); // shift page up
				tcbnotify.remove(); // remove banner from document
				tcbnotify = null;
				tcbnotifycontent = null;
			}
		}
	}
	console.log('Clearing banner 2');
	bannerparts = []; // clear storage ready for next time
	merchantsdone = {};
}

var winhost = window.location.host; // cache domain of this page
var merchantdata = {}; // object to cache notification data for each merchant
var merchantcallbacks = {}; // object to store callbacks for each merchant while there is already a merchant data request pending for it

function getMerchantData(host, callback){ // return merchant notification data to callback, from cache where possible
	var data = merchantdata[host];
	if(typeof(data) != 'undefined'){
		console.log('Merchant data found for '+host);
		callback(data); // data found in cache, return it to callback immediately
	}else{
		console.log('Merchant data not found for '+host);
		var callbacks = merchantcallbacks[host];
		if(typeof(callbacks) != 'undefined'){
			console.log('Adding callback for '+host);
			callbacks.push(callback); // data not found in cache, request already pending, so just add callback to queue and leave
		}else{
			console.log('Creating callbacks for '+host);
			merchantcallbacks[host] = [callback]; // data not found in cache, no request pending, so create queue with callback
			self.port.emit('mdata', host); // send message to main extension script asking for merchant notification data
		}
	}
}

self.port.on('mdata', function(res){
	var data = res.data;
	if(data && typeof(data.tt) == 'undefined'){ // if title text isn't set, use notification text with HTML tags stripped
		data.tt = data.t.replace(/(<([^>]+)>)/gi, '');
	}
	merchantdata[res.host] = data; // save merchant notification data to cache
	console.log('Merchant data saved for '+res.host);
	$.each(merchantcallbacks[res.host], function(){
		this(data); // call all pending callbacks for this merchant now that we have the data
	});
	delete merchantcallbacks[res.host]; // now that we're all done, delete callback queue for this merchant
});

function processLinks(root, stage){ // process any new links in the page, checking for TCB merchants
	// variables and function relating to content for banner, needed as processing of each link is (potentially) asynchronous
	var newlinks = false, done = false;
	var checkdone = function(){
		console.log('Waiting: '+waitingcount);
		if(done && newlinks){
			clearTimeout(bannertimeout);
			if(waitingcount == 0){
				console.log('Setting banner', bannerparts.length);
				//setBanner(); // all links have been processed, so set banner content now
				bannertimeout = setTimeout(setBanner, 0);
			}
		}
	};
	
	var checklink = function(){ // for each link element
		var host = this.hostname;
		if(host != '' && host != winhost){ // ignore non-URLs and links to other pages on this site
			newlinks = true; // set to show that at least one unprocessed link has been found, meaning a page change must have occured
			//var ele = this; // save reference to this link
			//console.log('Element', this);
			var $ele = $(this); // cache jQuery version of this link, as it's used multiple times
			//console.log(ele.href, ele.hostname);
			var thisstage = stage; // needed because the next part is potentially asynchronous, and stage may have changed before it gets called back - this preserves the original value at this point
			waitingcount++; // add to running count of elements waiting to be processed
			getMerchantData(host, function(TCBMerchant){ // fetch data for this merchant
				if(TCBMerchant){ // if there is any
					console.log('Stage '+thisstage, 'mdata', TCBMerchant);
					if(!TCBMerchant.hsr && (thisstage == 2 || !TCBMerchant.hpr)){ // if merchant not set to hide search results, and this isn't a paid result or not set to hide paid results (stage 2 == main search results area)
						$ele.before('<a href="'+TCBMerchant.u+'" title="'+TCBMerchant.tt+'" target="_blank" data-tcbdone="1"><img src="'+TCBData.assetspath+'new/logo19.png" style="margin-bottom: -3px;"></a> '); // insert TCB link before this link
					}
					if(!merchantsdone[TCBMerchant.i]){ // check to avoid duplicates in banner
						if(!TCBMerchant.hrb && typeof(TCBMerchant.c) != 'undefined'){ // check that this merchant is eligible for inclusion in banner
							bannerparts.push('<a href="'+TCBMerchant.u+'" target="_blank">'+TCBMerchant.n+' - '+TCBMerchant.c+' cashback</a>');
						}
						merchantsdone[TCBMerchant.i] = true;
					}
				}
				waitingcount--;
				checkdone();
			});
			$ele.attr('data-tcbdone', 1); // mark this link as processed so it can be ignored next time
		}
	};
	
	console.log('Stage: ' + stage);
	//(isads ? '' : 'li:not(#newsbox) ') + 'a[href!=""][data-tcbdone!=1]', root
	if(typeof(root) == 'undefined'){ // if root element to work within isn't set, i.e. this isn't being called from a MutationObserver
		console.log('Clearing banner');
		bannerparts = [];
		merchantsdone = {};
		if(!TCBData.hpr){
			stage = 1;
			$(elementqueryads, '#taw').each(checklink);
		}
		stage = 2;
		$(elementquery, '#search').each(checklink);
		if(!TCBData.hpr){
			stage = 3;
			$(elementqueryads, '#bottomads').each(checklink);
			stage = 4;
			$(elementqueryads, '#rhscol').each(checklink);
		}
		//laststage = stage;
	}else{
		/*if(stage <= laststage){ // only continue adding to banner content if stage has increased
			bannerparts = [];
			merchantsdone = {};
		}*/
		//laststage = stage;
		$(stage==2?elementquery:elementqueryads, root).each(checklink);
	}
	done = true;
	checkdone();
}

function init(){ // when DOM is ready
	$body = $('body');
	processLinks(); // process links now
	var MO = window.MutationObserver || window.WebKitMutationObserver;
	if(MO){
		new MO(function(mutations){ // create DOM mutation observer, needed to detect changes to results which occur via AJAX
			var len = mutations.length;
			for(var i = 0; i < len; i++){ // loop through MutationRecords
				var ele = mutations[i].target;
				//console.log(mutations[i].target.id);
				//console.log(mutations[i]);
				if(ele.id == 'taw'){ // top ads area
					console.log(mutations[i]);
					console.log('Match top ads');
					if(!TCBData.hpr){
						processLinks(ele, 1);
					}
				}else if(ele.id == 'search'){ // main search results area - this seems to be the best element to watch for changes, so ignore everything else (see below for why we can't just attach to it directly)
					console.log(mutations[i]);
					console.log('Match search');
					processLinks(ele, 2); // if this element has had subtree changes, process new links
				//}else if(ele.tagName == 'LI' && ele.className == 'ads-ad'){
				}else if(!TCBData.hpr){
					if(ele.id == 'bottomads'){ // bottom ads area
						console.log(mutations[i]);
						console.log('Match bottom ads');
						processLinks(ele, 3);
					}else if(ele.id == 'rhscol'){ // right side ads area
						console.log(mutations[i]);
						console.log('Match side ads');
						processLinks(ele, 4);
					}
				}
			}
		}).observe(document.getElementById('main'), {childList: true, subtree: true}); // attach mutation observer to high-level element, as the one we're really interested in may not always exist (due to AJAX changes)
	}else{
		var processLinksDelayed = function(){
			setTimeout(processLinks, 1000);
		};
		$(window).on('hashchange', processLinksDelayed);
		if(window.location.hash != ''){
			processLinksDelayed();
		}
	}
}