//var buttons = require('sdk/ui/button/action');
var tabs = require("sdk/tabs");
var ss = require("sdk/simple-storage");

/*var button = buttons.ActionButton({
  id: "mozilla-link",
  label: "Visit Mozilla",
  icon: {
    "16": "./icon-16.png",
    "32": "./icon-32.png",
    "64": "./icon-64.png"
  },
  onClick: handleClick
});

function handleClick(state) {
	console.log('Test');
  tabs.open("http://www.mozilla.org/");
}*/

var self = require('sdk/self');
var dataDir = self.data;
var pageMod = require('sdk/page-mod');
var pageWorker = require('sdk/page-worker');
var Request = require('sdk/request').Request;
var timers = require('sdk/timers');
var setTimeout = timers.setTimeout;
//var {Cc, Ci} = require("chrome");
//var parser = Cc["@mozilla.org/parserutils;1"].getService(Ci.nsIParserUtils);

// Library function to parse URL into components
function parseUri (str) {
	var	o   = parseUri.options,
		m   = o.parser[o.strictMode ? "strict" : "loose"].exec(str),
		uri = {},
		i   = 14;

	while (i--) uri[o.key[i]] = m[i] || "";

	uri[o.q.name] = {};
	uri[o.key[12]].replace(o.q.parser, function ($0, $1, $2) {
		if ($1) uri[o.q.name][$1] = $2;
	});

	return uri;
};

parseUri.options = {
	strictMode: false,
	key: ["source","protocol","authority","userInfo","user","password","host","port","relative","path","directory","file","query","anchor"],
	q:   {
		name:   "queryKey",
		parser: /(?:^|&)([^&=]*)=?([^&]*)/g
	},
	parser: {
		strict: /^(?:([^:\/?#]+):)?(?:\/\/((?:(([^:@]*)(?::([^:@]*))?)?@)?([^:\/?#]*)(?::(\d*))?))?((((?:[^?#\/]*\/)*)([^?#]*))(?:\?([^#]*))?(?:#(.*))?)/,
		loose:  /^(?:(?![^:@]+:[^:@\/]*@)([^:\/?#.]+):)?(?:\/\/)?((?:(([^:@]*)(?::([^:@]*))?)?@)?([^:\/?#]*)(?::(\d*))?)(((\/(?:[^?#](?![^?#\/]*\.[^?#\/.]+(?:[?#]|$)))*\/?)?([^?#\/]*))(?:\?([^#]*))?(?:#(.*))?)/
	}
};

function parseQueryStr(qs) {
	var a = qs.split('&');
    if (a == "") return {};
    var b = {};
    for (var i = 0; i < a.length; ++i)
    {
        var p=a[i].split('=');
        if (p.length != 2) continue;
        b[p[0]] = decodeURIComponent(p[1].replace(/\+/g, " "));
    }
    return b;
}

// main data stores
var version = self.version;
var countryselurl = 'http://www.topcashback.co.uk/notifierregion';
var countrydata;
var settings = {};
var merchants = {};
var TCBData = {};
var dismissedmerchants = {}; // list of merchants for which banner has been dismissed by user
var merchantclicks = {};
var csdone = {};
var updatetimer;

var merchantpagemod = {};
var merchantworkers = {};

function updateData(callback) { // fetch main data feed from server
	console.log('Updating data', typeof(callback));
	Request({url: countrydata.url + '?auth=t3stF33dAuth&v=' + version, onComplete: function(response) {
		console.log('Got response');
		var delay;
		if (response.status == 200) {
			console.log('Response OK');
			var data = response.json;
			//console.log('Success', data);
			settings = data.settings;
			//TCBData = JSON.stringify({logo: settings.logo, hpr: settings.hpr});
			if (typeof(settings.region) == 'undefined') {
				settings.region = countrydata.ID.toLowerCase();
			}
			if (typeof(settings.t) == 'undefined') {
				settings.t = settings.ctext;
			}
			if (typeof(settings.bt) == 'undefined') {
				settings.bt = 'Get Cashback Now';
			}
			if (typeof(settings.ts) == 'undefined') {
			settings.ts = 'Your tracking has been set for %n%';
			}
			TCBData = {assetspath: '//'+settings.domain+'/toolbarassets/'+settings.region+'/', hpr: settings.hpr};
			/*if (!settings.logo) {
				//settings.logo = chrome.extension.getURL('logo-19.png');
			}*//*else if (settings.logo.substr(0, 1) == '/') {
				var url = parseUri(countrydata.url);
				settings.logo = '//' + url.host + settings.logo;
			}*/
			merchants = data.merchants;
			delay = settings.expiry * 1000;
		} else { // if error fetching data from server, try again after minimum time
			delay = 600000;
		}
		timers.clearTimeout(updatetimer); // clear any existing timer for this, just in case
		updatetimer = setTimeout(updateData, delay);
		console.log('Done');
		/*console.log('Next update set for '+delay+' milliseconds');
		console.log((delay/1000)+' seconds');
		console.log((delay/60000)+' minutes');*/
		if (typeof(callback) == 'function') {
			callback(response.status == 200);
		}
	}}).get();
}

exports.main = function(options, callbacks) {
	if (options.loadReason == 'install') {
		console.log('New install - clearing existing data');
		delete ss.storage.countrydata;
	}
	countrydata = ss.storage.countrydata;
	if (typeof(countrydata) != 'undefined') {
		updateData(); // trigger initial data feed fetch now
	} else {
		tabs.open(countryselurl + '?v=' + version);
	}
}

function replaceVars(merchant, param) {
	for (var i = 1, argslength = arguments.length; i < argslength; i++) {
		var arg = arguments[i];
		if (typeof(merchant[arg]) == 'undefined') {
			merchant[arg] = settings[arg];
		}
		if (typeof(merchant[arg]) == 'string') {
			merchant[arg] = merchant[arg].replace(/%([A-Z0-9]+)%/gi, function(fullstr, varname) {
				//console.log('Match', fullstr, varname);
				if (typeof(merchant[varname]) == 'string') {
					return merchant[varname];
				} else if (typeof(settings[varname]) == 'string') {
					return settings[varname];
				} else {
					return '';
				}
			});
		}
	}
}

function getMerchant(host) { // get merchant record and fill in gaps
	var merchant;
	if (typeof(host) == 'object') {
		merchant = host;
	} else {
		if (host=='') {return;}
		merchant = merchants[host];
	}
	if (typeof(merchant) != 'undefined') {
		if (!merchant.done) {
			/*if (typeof(merchant.t) == 'undefined') {
				//merchant.t = settings.ctext.replace('%c%', merchant.c); // if no custom text set, generate it
				merchant.t = settings.t;
			}
			if (typeof(merchant.bt) == 'undefined') {
				merchant.bt = settings.bt;
			}
			if (typeof(merchant.ts) == 'undefined') {
				merchant.ts = settings.ts;
			}
			if (typeof(merchant.tt) == 'undefined') {
				merchant.tt = settings.tt;
			}*/
			replaceVars(merchant, 't', 'tt', 'bt', 'ts', 'u');
			if (typeof(merchant.cs) == 'undefined') {
				merchant.cs = settings.cs;
			}
			/*if (typeof(merchant.u) == 'undefined') {
				if (typeof(settings.u) != 'undefined') {
					merchant.u = settings.u;
					replaceVars(merchant, 'u');
				} else {
				merchant.u = 'http://' + settings.domain + '/' + merchant.i + '/?ref=tb'; // if no custom URL set, generate it
				}
			} else { // custom URL set in feed for this merchant
				replaceVars(merchant, 'u');
				if (merchant.u.substr(0, 1)=='/') {
					merchant.u = 'http://' + settings.domain + merchant.u; // support root-relative URLs
				}
			}*/
			if (typeof(merchant.u) == 'undefined') {
				merchant.u = 'http://' + settings.domain + '/' + merchant.i + '/?ref=tb'; // if no custom URL set, generate it
			} else {
				if (merchant.u.substr(0, 1)=='/') {
					merchant.u = 'http://' + settings.domain + merchant.u; // support root-relative URLs
				}
			}

			if (typeof(merchant.rUrl) == 'undefined') {
				merchant.rUrl = host;
			}
			
			merchant.done = true;
		}
		if (typeof(merchantclicks[merchant.i]) != 'undefined') {
			merchant.trackingset = true;
			csdone[merchant.i] = true;
			dismissedmerchants[merchant.i] = 2;
			delete merchantclicks[merchant.i];
		} else {
			delete merchant.trackingset;
		}
		merchant.dismissed = dismissedmerchants[merchant.i];
	}
	return merchant;
}

/*function updateWorkers(merchantid) {
	if (typeof(merchantworkers[merchantid]) != 'undefined') {
		$.each(merchantworkers[merchantid], function() {
			worker.port.emit('TCBMerchant', merchant);
		});
	}
}*/

function dismissMerchant(merchantid) {
	dismissedmerchants[merchantid] = 2; // save this for this merchant
	var include = merchantpagemod[merchantid].include;
	console.log('this.include', include);
	var len = include.length;
	for (var i = 0; i < len; i++) {
		include.remove(include[0]);
	}
}

// Check each page being loaded by the browser, at the earliest opportunity
tabs.on('ready', function(details) {
	console.log('Tab load: '+details.url);
	var url = parseUri(details.url);
	var host = url.host;
	var merchant = getMerchant(host);
	if (typeof(merchant) != 'undefined') { // if there is a merchant record for this domain
		var merchantid = merchant.i;
		//alert(merchantid);
		console.log('Found merchant: ' + merchantid);
		if (typeof(merchantpagemod[merchantid]) == 'undefined' && ((!merchant.hcr && dismissedmerchants[merchant.i] != 2) || merchant.trackingset)) { // if banner for this merchant hasn't already been dismissed
			console.log('Creating pagemod');
			var firstattach = true;
			merchantworkers[merchantid] = [];
			merchantpagemod[merchantid] = pageMod.PageMod({
				//include: details.url,
				include: ['http://'+host+'/*', 'https://'+host+'/*'],
				attachTo: ["existing", "top"],
				contentScriptWhen: "start",
				contentStyleFile: dataDir.url('notify.css'),
				contentScriptOptions: {TCBData: TCBData},
				contentScriptFile: [dataDir.url('jquery.min.js'), dataDir.url('notify.js')],
				onAttach: function(worker) {
					console.log('Attached', worker);
					//worker.port.emit('TCBData', TCBData);
					console.log('First attach:', firstattach);
					if (firstattach) {
						firstattach = false;
					} else {
						merchant = getMerchant(merchant);
					}
					console.log('Sending TCBMerchant', merchant);
					worker.port.emit('TCBMerchant', merchant);
					/*console.log('this.include', this.include);
					this.include.remove(details.url);
					console.log('Cleared include');
					console.log('this.include', this.include);*/
					//console.log('include:', thisPageMod.include);
					//thisPageMod.include.remove(0);
					merchantworkers[merchantid].push(worker);
					var removeWorker = function() {
						var workers = merchantworkers[merchantid];
						var index = workers.indexOf(this);
						if (index != -1) {
							workers.splice(index, 1);
							console.log('Removed worker');
						}
						console.log('Workers: ', workers.length);
						if (workers.length == 0 && dismissedmerchants[merchantid] == 2) {
							console.log('Removing pagemod');
							setTimeout(function() {
								merchantpagemod[merchantid].destroy();
								delete merchantpagemod[merchantid];
								delete merchantworkers[merchantid];
								console.log('Removed pagemod');
							}, 0);
						}
					};
					worker.on('detach', removeWorker);
					worker.port.on('dismiss', function() { // notification box has been dismissed
						dismissMerchant(merchantid);
						console.log('this.include 2', include);
						removeWorker.call(worker);
						console.log(merchantid+' dismissed');
					});
					worker.port.on('minimise', function() { // notification box has been minimised
						dismissedmerchants[merchantid] = 1; // save this for this merchant
						//updateWorkers(merchantid, 'dismissed', 1);
					});
					worker.port.on('restore', function() { // notification box has been restored
						delete dismissedmerchants[merchantid]; // save this for this merchant
						//updateWorkers(merchantid, 'dismissed', null);
					});
					if (merchant.trackingset && merchant.dismissed == 2) {
						dismissMerchant(merchantid);
					}
				}
			});
		}
		if (merchant.cs && settings.li && !csdone[merchant.i]) {
			console.log(merchant.i+' CS loading');
			csdone[merchant.i] = true;
			/*tabs.open({url: 'http://www.topcashback.co.uk/EarnCashback.aspx?mpurl=' + merchant.i + '&instant=True', inBackground: true, onLoad: function(tab) {
				console.log(merchant.i+' CS loaded');
				setTimeout(function() {
					tab.close();
					console.log(merchant.i+' CS removed');
				}, 2000);}
			});*/
			//contentScript: "self.port.emit('loaded', location.href);", contentScriptWhen: 'end'
			var page = pageWorker.Page({contentURL: 'http://' + settings.domain + '/EarnCashback.aspx?mpurl=' + merchant.i + '&instant=True&notifier=cs'});
			var timeout;
			page.on('pageshow', function() {
				console.log(merchant.i+' CS loaded');
				timers.clearTimeout(timeout);
				timeout=setTimeout(function() {
					page.destroy();
					page = null;
					console.log(merchant.i+' CS removed');
				}, 2000);
			});
			/*page.on('*', function(e, d) {
				console.log('page.on', e, d, page.contentURL);
			});
			page.port.on('*', function(e, d) {
				console.log('page.port.on', e, d, page.contentURL);
			});*/
		}
	} else if (host == settings.domain && url.path == '/redirect.aspx') {
		var queryparams = parseQueryStr(url.query);
		console.log('Clickthrough page', url.query, queryparams);
		var merchantid = queryparams['mpurl'];
		if (merchantid != '') {
			merchantclicks[merchantid] = true;
			//updateWorkers(merchantid);
		}
	}
});

pageMod.PageMod({
	//include: ['http://www.google.co.uk*', 'https://www.google.co.uk*', 'http://www.google.com*', 'https://www.google.com*'],
	include: ['http://www.google.*', 'https://www.google.*'],
	attachTo: ["existing", "top"],
	contentScriptWhen: "start",
	contentStyleFile: dataDir.url('notify.css'),
	contentScriptFile: [dataDir.url('jquery.min.js'), dataDir.url('sri.js')],
	onAttach: function(worker) {
		worker.port.emit('TCBData', TCBData);
		worker.port.on('mdata', function(host) {
			worker.port.emit('mdata', {host: host, data: getMerchant(host) || null});
		});
	}
});

pageMod.PageMod({
	include: ['http://www.topcashback.co.uk/notifierregion*', 'https://www.topcashback.co.uk/notifierregion*'],
	attachTo: ["existing", "top"],
	contentScriptWhen: "start",
	contentScriptFile: [dataDir.url('jquery.min.js'), dataDir.url('region.js')],
	onAttach: function(worker) {
		var url = parseUri(worker.tab.url)
		var pageregion = url.path.substr(15);
		var region = typeof(countrydata) != 'undefined' && countrydata.ID ? '/' + countrydata.ID : '';
		if (region == pageregion && parseQueryStr(url.query).v == version) {
			worker.port.on('countrysel', function(data) {
				timers.clearTimeout(updatetimer);
				countrydata = data.countrydata;
				/*if (countrydata.url.substr(0, 4) != 'http') {
					countrydata.url = 'http://' + countrydata.url;
				}*/
				console.log('New country data', countrydata);
				ss.storage.countrydata = countrydata;
				//worker.port.emit('loadPage', {url: countryselurl + '/' + countrydata.ID});
				//worker.tab.url = countryselurl + '/' + countrydata.ID;
				if (typeof(countrydata) != 'undefined') {
					worker.port.emit('postMessage', {tcbstatus: 'loading'});
					updateData(function(res) {
						if (res) {
							worker.tab.url = 'http://' + settings.domain + '/notifiersuccess?v=' + version;
						} else {
							worker.port.emit('postMessage', {tcbstatus: 'loadfail'});
						}
					});
				}
			});
		} else {
			worker.tab.url = countryselurl + region + '?v=' + version;
		}
	}
});

pageMod.PageMod({
	include: ['http://www.topcashback.co.uk/toolbarregion*', 'https://www.topcashback.co.uk/toolbarregion*'],
	attachTo: ["existing", "top"],
	contentScriptWhen: "start",
	onAttach: function(worker) {
		worker.tab.url = countryselurl;
	}
});